---------------------------------------------------------------------------------------	
--        +++++++++++++++++++++++++++++++++
--        +          NODOMEMORIA          +
--        +                               +
--        +  ***********    ************  +
--        +  * Wrapper *----*          *  +
--        +  * BlockRam*----* Roteador *  +
--        +  *         *    *          *  +
--        +  ***********    ************  +
--        +++++++++++++++++++++++++++++++++
---------------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use work.packet.all;

entity NodoMemoria is
port(
	clock: 		in std_logic;
	reset:		in std_logic;
	addressC: 	in reg8;
	data_in: 	in reg32;
	rx:		in reg4;
	ack_rx:		out reg4;
	data_out:	out reg32;
	tx:		out reg4;
	ack_tx:		in reg4);
end NodoMemoria;

architecture NodoMemoria of NodoMemoria is

component WrapperBlockram is
	port(
	clock:		in std_logic;
	reset:		in std_logic;
	addressC:	in reg8;
	rx:		in std_logic;
	ack_rx:		out std_logic;
	data_in:	in reg8;
	tx:		out std_logic;
	ack_tx:		in std_logic;
	data_out:	out reg8);
end component;

component Roteador is
port(
	clock: 		in std_logic;
	reset:		in std_logic;
	address: 	in reg8;
	data_in: 	in array5_reg8;
	rx:		in reg5;
	ack_rx:		out reg5;
	data_out:	out array5_reg8;
	tx:		out reg5;
	ack_tx:		in reg5);
end component;

signal data_inLOCAL, data_outLOCAL: reg8;
signal data_inR, data_outR: array5_reg8;
signal rxR,ack_rxR,txR,ack_txR: reg5;
signal rxLOCAL, txLOCAL, ack_rxLOCAL,ack_txLOCAL: std_logic;

-- debug 


begin
--------------------------------------------------------------
-- SINAIS DA INTERFACE DO WRAPPERSERIAL
--------------------------------------------------------------	


--------------------------------------------------------------
-- SINAIS DA INTERFACE DO WRAPPERSERIAL
--------------------------------------------------------------	
	WB: WrapperBlockram
	port map(
	clock => clock,
	reset => reset,
	addressC => addressC,
	rx => txLOCAL,
	ack_rx => ack_txLOCAL,
	data_in => data_outLOCAL,
	tx => rxLOCAL,
	ack_tx => ack_rxLOCAL,
	data_out =>	data_inLOCAL);
	
--------------------------------------------------------------
-- SINAIS DA INTERFACE DO ROTEADOR
--------------------------------------------------------------	
-- PORTAS DE ENTRADA
	data_inR(EAST) <= data_in(7 downto 0);
	data_inR(WEST) <= data_in(15 downto 8);
	data_inR(NORTH) <= data_in(23 downto 16);
	data_inR(SOUTH) <= data_in(31 downto 24);
	data_inR(LOCAL) <= data_inLOCAL;
	rxR <= rxLOCAL & rx;
	ack_txR <= ack_txLOCAL & ack_tx;
	
-- PORTAS DE SAIDA
	data_out(7 downto 0) <= data_outR(EAST);
	data_out(15 downto 8)<= data_outR(WEST);
	data_out(23 downto 16) <= data_outR(NORTH);
	data_out(31 downto 24) <= data_outR(SOUTH);
	data_outLOCAL <= data_outR(LOCAL);
	ack_rx <= ack_rxR(3 downto 0);
	ack_rxLOCAL <= ack_rxR(LOCAL);
	tx <= txR(3 downto 0);
	txLOCAL <= txR(LOCAL);

	ROT : Roteador
	port map(
	clock=>clock,
	reset=>reset,
	address=>addressC,
	data_in=>data_inR,
	rx=> rxR,
	ack_rx=> ack_rxR,
	data_out=>data_outR,
	tx=>txR,
	ack_tx=>ack_txR);

end NodoMemoria;