library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.packet.all;

entity sistemaNOC is
port(
	clock:	in std_logic;
	sw1:		in std_logic;
-- Retira daqui
	txd:		in std_logic;
	rxd:		out std_logic;
-- ate aqui para simular	
-- Retira daqui
--	tx_av:	in std_logic;
--	rx_busy:	in std_logic;
--	rx_start:	out std_logic;
--	tx_data:	in std_logic_vector(7 downto 0);
--	rx_data:	out std_logic_vector(7 downto 0);
-- at aqui para prototipar
	display:	out std_logic_vector(13 downto 0));
end sistemaNOC;

architecture sistemaNOC of sistemaNOC is

component NodoSerial is
port(
	clock: 		in std_logic;
	reset:		in std_logic;
	state:		out reg8;
	addressC: 	in reg8;
---- habilitar os sinais txd e rxd  para prototipar ----
 	txd:		in std_logic;
	rxd:		out std_logic;
---- retirar a partir daqui -------------------------------------
--	rx_data:	out reg8;  
--	rx_start:	out std_logic;                     
--	rx_busy:	in std_logic;                     	
--	tx_data:	in reg8; 
--	tx_av:		in std_logic;                        	
---- at aqui para prototipar -----------------------------------
	data_in: 	in reg32;
	rx:			in reg4;
	ack_rx:		out reg4;
	data_out:	out reg32;
	tx:			out reg4;
	ack_tx:		in reg4);
end component;

component NodoMemoria is
port(
	clock: 		in std_logic;
	reset:		in std_logic;
	addressC: 	in reg8;
	data_in: 	in reg32;
	rx:		in reg4;
	ack_rx:		out reg4;
	data_out:	out reg32;
	tx:		out reg4;
	ack_tx:		in reg4);
end component;

--interface de codificao do display
component displaydecoder is
port
(
	datain: in std_logic_vector (3 downto 0);
 	dataout: out std_logic_vector (6 downto 0)
);
end component;


-- sistema
signal reset: std_logic;

-- roteador
signal addressN00, addressN10,addressN01,addressN11: reg8;
signal data_inN00, data_inN10, data_inN01, data_inN11: reg32;
signal data_outN00, data_outN10, data_outN01, data_outN11: reg32;
signal rxN00, rxN10, rxN01, rxN11: reg4;
signal ack_rxN00, ack_rxN10, ack_rxN01, ack_rxN11: reg4;
signal txN00, txN10, txN01, txN11: reg4;
signal ack_txN00, ack_txN10, ack_txN01, ack_txN11: reg4;

-- serial interface
signal state: reg8;

begin


	reset <= not sw1;
	
	addressN00 <= x"00";
	addressN10 <= x"10";
	addressN01 <= x"01";
	addressN11 <= x"11";

	--display high
 	dispdechigh: displaydecoder 
 	port map
	(
 		datain => state(7 downto 4),
 		dataout => display (13 downto 7) 
 	);
	
	--display low
	dispdeclow: displaydecoder
 	port map
	(
 		datain => state(3 downto 0),
 		dataout => display (6 downto 0)
 	);

	NS: NodoSerial
	port map(
	clock => clock,
	reset => reset,
	state => state,
	addressC => addressN00,
---- habilitar os sinais txd e rxd  para prototipar ----
 	txd => txd,
	rxd => rxd,
---- retirar a partir daqui -------------------------------------
--	rx_data => rx_data,
--	rx_start => rx_start,
--	rx_busy => rx_busy,
--	tx_data => tx_data,
--	tx_av => tx_av,
---- at aqui para prototipar -----------------------------------
	data_in => data_inN00,
	rx => rxN00,
	ack_rx => ack_rxN00,
	tx => txN00,
	ack_tx => ack_txN00,
	data_out => data_outN00);


	NM0: NodoMemoria
	port map(
	clock => clock,
	reset => reset,
	addressC => addressN10,
	data_in => data_inN10,
	rx => rxN10,
	ack_rx => ack_rxN10,
	tx => txN10,
	ack_tx => ack_txN10,
	data_out => data_outN10);

	NM1: NodoMemoria
	port map(
	clock => clock,
	reset => reset,
	addressC => addressN01,
	data_in => data_inN01,
	rx => rxN01,
	ack_rx => ack_rxN01,
	tx => txN01,
	ack_tx => ack_txN01,
	data_out => data_outN01);

	NM2: NodoMemoria
	port map(
	clock => clock,
	reset => reset,
	addressC => addressN11,
	data_in => data_inN11,
	rx => rxN11,
	ack_rx => ack_rxN11,
	tx => txN11,
	ack_tx => ack_txN11,
	data_out => data_outN11);
	
----------------------------------------------------------------
-- SINAIS DE LIGACAO DOS ROTEADORES
----------------------------------------------------------------
----------------------------------------------------------------
-- SINAIS DE LIGACAO DOS ROTEADORES
----------------------------------------------------------------
	data_inN00(7 downto 0)<=data_outN10(15 downto 8);
	data_inN00(23 downto 8)<=(others=>'0');
	data_inN00(31 downto 24)<=data_outN01(23 downto 16);
	
	data_inN10(7 downto 0)<=(others=>'0');
	data_inN10(15 downto 8)<=data_outN00(7 downto 0);
	data_inN10(23 downto 16)<=(others=>'0');
	data_inN10(31 downto 24)<=data_outN11(23 downto 16);

	data_inN01(7 downto 0)<=data_outN11(15 downto 8);
	data_inN01(15 downto 8)<=(others=>'0');
	data_inN01(23 downto 16)<=data_outN00(31 downto 24);
	data_inN01(31 downto 24)<=(others=>'0');

	data_inN11(7 downto 0)<=(others=>'0');
	data_inN11(15 downto 8)<=data_outN01(7 downto 0);
	data_inN11(23 downto 16)<=data_outN10(31 downto 24);
	data_inN11(31 downto 24)<=(others=>'0');

	rxN00(0)<=txN10(1);
	rxN00(2 downto 1) <= (others=>'0');
	rxN00(3)<=txN01(2);

	rxN10(0)<='0';
	rxN10(1) <= txN00(0);
	rxN10(2)<='0';
	rxN10(3)<=txN11(2);

	rxN01(0)<=txN11(1);
	rxN01(1)<='0';
	rxN01(2)<=txN00(3);
	rxN01(3)<='0';

	rxN11(0)<='0';
	rxN11(1)<=txN01(0);
	rxN11(2)<=txN10(3);
	rxN11(3)<='0';
	
	ack_txN00(0)<=ack_rxN10(1);
	ack_txN00(2 downto 1) <= (others=>'0');
	ack_txN00(3)<=ack_rxN01(2);

	ack_txN10(0)<='0';
	ack_txN10(1) <= ack_rxN00(0);
	ack_txN10(2)<='0';
	ack_txN10(3)<=ack_rxN11(2);

	ack_txN01(0)<=ack_rxN11(1);
	ack_txN01(1)<='0';
	ack_txN01(2)<=ack_rxN00(3);
	ack_txN01(3)<='0';

	ack_txN11(0)<='0';
	ack_txN11(1)<=ack_rxN01(0);
	ack_txN11(2)<=ack_rxN10(3);
	ack_txN11(3)<='0';

end sistemaNOC;